/*********************************************************************************************************
* Software License Agreement (BSD License)                                                               *
* Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
*													 *
* Copyright (c) 2008, WIDE Project and NICT								 *
* All rights reserved.											 *
* 													 *
* Redistribution and use of this software in source and binary forms, with or without modification, are  *
* permitted provided that the following conditions are met:						 *
* 													 *
* * Redistributions of source code must retain the above 						 *
*   copyright notice, this list of conditions and the 							 *
*   following disclaimer.										 *
*    													 *
* * Redistributions in binary form must reproduce the above 						 *
*   copyright notice, this list of conditions and the 							 *
*   following disclaimer in the documentation and/or other						 *
*   materials provided with the distribution.								 *
* 													 *
* * Neither the name of the WIDE Project or NICT nor the 						 *
*   names of its contributors may be used to endorse or 						 *
*   promote products derived from this software without 						 *
*   specific prior written permission of WIDE Project and 						 *
*   NICT.												 *
* 													 *
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED *
* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR *
* ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 	 *
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 	 *
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR *
* TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF   *
* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.								 *
*********************************************************************************************************/

/* Messages queues module.
 * 
 * This module provides the support functions for queueing and picking messages.
 * See queues.h for more information.
 */

#include <errno.h>

#include "waaad-internal.h"

/* The global queues pointers are actually declared here */
meq_t * g_meq_incoming = NULL;	/* Received messages */
meq_t * g_meq_outgoing = NULL;	/* Messages to send */
meq_t * g_meq_local = NULL;	/* Messages for local handling */

/* Initialize the module */
int meq_init ( void )
{
	/* Initialize the module */
	
	/* Initialize the global queues */
	
	
	TRACE_DEBUG (INFO, "Queues module initialized");
	TRACE_DEBUG (FULL, "@@@ Not implemented yet." );
	return 0;
}

/* End of the module */
int meq_fini ( void )
{
	TRACE_DEBUG (FULL, "Unloading queues module...");
	TRACE_DEBUG (FULL, "@@@ Not implemented yet." );
	return 0;
}


int meq_new ( meq_t ** queue )
{
	TRACE_DEBUG (FULL, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}


int meq_del ( meq_t ** queue )
{
	TRACE_DEBUG (FULL, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}


int meq_length ( meq_t * queue, int * length )
{
	TRACE_DEBUG (FULL, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}


int meq_post ( meq_t * queue, msg_t * msg )
{
	TRACE_DEBUG (FULL, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}


int meq_get ( meq_t * queue, msg_t ** msg )
{
	TRACE_DEBUG (FULL, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}


int meq_tryget ( meq_t * queue, msg_t ** msg )
{
	TRACE_DEBUG (FULL, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}


int meq_timedget ( meq_t * queue, msg_t ** msg, const struct timespec *abstime )
{
	TRACE_DEBUG (FULL, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}




